﻿package funnel {
	import funnel.I2CDevice;

	/**
	 * This is the class to express HMC6352 devices
	 *
	 */
	public class HMC6352 extends I2CDevice {

		public var heading:Number;

		public function HMC6352(ioModule, address:uint = 0x21) {
			super(ioModule, address);

			heading = 0;

			_io.sendSysex(I2C_REQUEST, [WRITE, address, 'G'.charCodeAt(0), 0x74, 0x51]);
			_io.sendSysex(I2C_REQUEST, [WRITE, address, 'A'.charCodeAt(0)]);
			_io.sendSysex(I2C_REQUEST, [READ_CONTINUOUS, address, 0x7F, 0x02]);
		}

		public override function handleSysex(command:uint, data:Array):void {
			if (command != I2C_REPLY) {
				return;
			}

			heading = (int(data[2]) * 256 + int(data[3])) / 10.0;
		}
	}
}