﻿package funnel{
	import funnel.IOModule;

	/**
	 * This is the class to express I2C devices
	 *
	 */
	public class I2CDevice {

		public static const I2C_REQUEST:uint = 0x76;
		public static const I2C_REPLY:uint = 0x77;

		protected static const WRITE:uint = 0;
		protected static const READ:uint = 1;
		protected static const READ_CONTINUOUS:uint = 2;
		protected static const STOP_READING:uint = 3;

		public var address:uint;

		protected var _io:IOModule;

		public function I2CDevice(ioModule:*, slaveAddress:uint):void {
			if (ioModule is IOModule) {
				_io = ioModule;
			} else if (ioModule is IOSystem) {
				_io = ioModule.ioModule(0);
			} else {
				throw new ArgumentError("the first argument should be an IOModule or a IOSystem");
				return;
			}

			address = slaveAddress;
			_io.addSysexListener(this);
		}

		public function update():void {
			// To be implemented in sublasses
		}

		public function handleSysex(command:uint, data:Array):void {
			// To be implemented in sublasses
		}
	}
}